#ifndef GMC_COMMON_H
#define GMC_COMMON_H

#include "gmc-common_global.h"

#include <QtGlobal>
#include <qnamespace.h>

enum OperationsClass { UndefinedOperationsClass     = 0x0
                     , ElementOperationsClass       = 0x1
                     , DisplayOperationsClass       = 0x2
                     , ServiceOperationsClass       = 0x4
                     , WidgetOperationsClass        = 0x8 };

enum OperationType { UndefinedOperation             = 0x0
//SupplementOperation
                   , GetSupplementOperation         = 0x1
                   , RemoveSupplementOperation      = 0x2
//ElementOperationsClass
                   , CreateOperation                = 0x4
                   , ReadContentOperation           = 0x8
                   , ReadPropertyLightOperation     = 0x10
                   , ReadPropertyHeavyOperation     = 0x20
                   , UpdateOperation                = 0x40
                   , DeleteOperation                = 0x80
//WidgetOperationClass
                   , ImportOperation                = 0x100
                   , ExportOperation                = 0x200
                   , PrintOperation                 = 0x400
//DisplayOperationsClass
                   , ChangeDisplayOperation         = 0x800
//ServiceOperationsClass
                   , StartOperation                 = 0x1000
                   , StopOperation                  = 0x2000
                   , RestartOperation               = 0x4000
                   , ReloadOperation                = 0x8000
                   , ControlOperation               = 0x10000
//LoginOperationClass
                   , LoginOperation                 = 0x20000
                   , LogoutOperation                = 0x40000
//UserOperationClass
                   , UserOperation03                = 0x1000000000000000
                   , UserOperation02                = 0x2000000000000000
                   , UserOperation01                = 0x4000000000000000
                   , UserOperation00                = 0x8000000000000000 };

enum ElementWidgetRole { HiddenElementWidgetRole
                       , ViewEditElementWidgetRole
                       , CreateElementWidgetRole
                       , _CountElementWidgetRoles };

enum ExtendedItemDataRole { ChoiceTreeNodeProxyModelCheckedRole = Qt::UserRole
                          , ChoiceTreeNodeProxyModelBlockedRole
                          , TreeNodeIdRole
                          , TreeNodeExpectedParentIdRole
                          , ElementTitleRole
                          , ElementElementTypeRole
                          , ElementGroupElementTypeRole
                          , ElementTabDecorationRole };

#endif
