#ifndef PROCESS_H
#define PROCESS_H

#include "gmc-common_global.h"

#include <QProcess>


class GMC_COMMON_SHARED_EXPORT Process : public QProcess
{
    Q_OBJECT

public:
    explicit Process(QObject* parent = nullptr);

public:
    Process& simpleStart(const QString& command,
                         const QStringList& arguments = QStringList(),
                         const bool expectSuccess = true);
    const QString output();
};

#endif // PROCESS_H
